package com.fg.scripting;

import com.fg.scripting.exception.ClassInstantiationException;

/**
 * This interface allows to create instance created after refresh of the scripting class inside ScriptingProxy.
 *
 * @author Jan Novotný, FG Forrest a.s. (c) 2007
 * @version $Id: ProxyInstanceFactory.java,v 1.2 2009/11/15 20:05:12 u_novoj Exp $
 */
public interface ProxyInstanceFactory {

	/**
	 * Reinstantiate inner groovy instance.
	 * @param clazz
	 * @return new instance
	 */
	Object createInstance(Class clazz) throws ClassInstantiationException;

}
