package com.fg.scripting.groovy;

import com.fg.mock.JavaHelloWorldInterface;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Description
 *
 * @author Jan Novotný, FG Forrest a.s. (c) 2007
 * @version $Id: SpringGroovySupportTest.java,v 1.3 2009/11/15 20:05:10 u_novoj Exp $
 */
public class SpringGroovySupportTest extends AbstractGroovyTest {
	private ClassPathXmlApplicationContext ctx;

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		ctx = new ClassPathXmlApplicationContext(
				"META-INF/spring/spring-groovy.xml"
		);
	}

	public void testLoadGroovyClassFail() throws Exception {
		Object mainGroovyInstance = ctx.getBean("mainGroovyClass");
		try {
			mainGroovyInstance.getClass().getMethod("helloWorld");
			fail("Spring must have changed its implementation ;-)");
		} catch(NoSuchMethodException ignored) {
			//yes, this is okay - Spring provides instance wrapped into an JDK proxy, so that only methods declared
			//in Java interfaces are available in such proxy
		}
	}

	public void testLoadGroovyClassFailAgain() throws Exception {
		Object myGroovyInstance = ctx.getBean("mainGroovyClass");
		try {
			myGroovyInstance.getClass().getMethod("helloWorld");
			fail("Spring must have changed its implementation ;-)");
		} catch(NoSuchMethodException ignored) {
			//yes, this is okay - Spring provides instance wrapped into an JDK proxy, so that only methods declared
			//in Java interfaces are available in such proxy
		}
	}

	public void testLoadGroovyClass() throws Exception {
		JavaHelloWorldInterface myGroovyInstance = (JavaHelloWorldInterface)ctx.getBean("mainGroovyClass");
		assertEquals("Hello Universe.", myGroovyInstance.sayHello());
	}	

}